package com.ruoyi.web.controller.mall;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.mall.domain.Sku;
import com.ruoyi.mall.domain.query.SkuQuery;
import com.ruoyi.mall.domain.vo.SkuVO;
import com.ruoyi.mall.service.SkuService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.util.List;
/**
 * sku信息Controller
 *
 * @author zcc
 * @date 2022-11-28
 */
@Api(description ="sku信息接口列表")
@RestController
@RequestMapping("/pms/sku")
public class SkuController extends BaseController {
    @Autowired
    private SkuService service;

    @ApiOperation("查询sku信息列表")
    @PreAuthorize("@ss.hasPermi('pms:sku:list')")
    @PostMapping("/list")
    public ResponseEntity<Page<Sku>> list(@RequestBody SkuQuery query, Pageable page) {
        service.getOutProductId(query);
        List<Sku> list = service.selectList(query, page);
        return ResponseEntity.ok(new PageImpl<>(list, page, ((com.github.pagehelper.Page)list).getTotal()));
    }

    @ApiOperation("导出sku信息列表")
    @PreAuthorize("@ss.hasPermi('pms:sku:export')")
    @Log(title = "sku信息", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public ResponseEntity<String> export(SkuQuery query) {
        List<Sku> list = service.selectList(query, null);
        ExcelUtil<SkuVO> util = new ExcelUtil<>(SkuVO.class);
        return ResponseEntity.ok(util.writeExcel(BeanUtil.copyToList(list,SkuVO.class), "sku信息数据"));
    }

    @ApiOperation("获取sku信息详细信息")
    @PreAuthorize("@ss.hasPermi('pms:sku:query')")
    @GetMapping(value = "/{id}")
    public ResponseEntity<Sku> getInfo(@PathVariable("id") Long id) {
        return ResponseEntity.ok(service.selectById(id));
    }

    @ApiOperation("新增sku信息")
    @PreAuthorize("@ss.hasPermi('pms:sku:add')")
    @Log(title = "sku信息", businessType = BusinessType.INSERT)
    @PostMapping
    public ResponseEntity<Integer> add(@RequestBody Sku sku) {
        return ResponseEntity.ok(service.insert(sku));
    }

    @ApiOperation("修改sku信息")
    @PreAuthorize("@ss.hasPermi('pms:sku:edit')")
    @Log(title = "sku信息", businessType = BusinessType.UPDATE)
    @PutMapping
    public ResponseEntity<Integer> edit(@RequestBody Sku sku) {
        return ResponseEntity.ok(service.update(sku));
    }

    @ApiOperation("删除sku信息")
    @PreAuthorize("@ss.hasPermi('pms:sku:remove')")
    @Log(title = "sku信息", businessType = BusinessType.DELETE)
	@DeleteMapping("/{id}")
    public ResponseEntity<Integer> remove(@PathVariable Long id) {
        return ResponseEntity.ok(service.deleteById(id));
    }
}
